LeetCode第1题

1.Two Sum

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].
解题实录:
方法一:哈希表。将每个数字放在map中,历遍数组,如果出现和数组中的某一个值相加为target的时候,break。

public class Solution {
    public int[] twoSum(int[] nums, int target) {
        int[]res = new int[2];
        if(nums==null||nums.length<2)
            return null;
        HashMap<Integer,Integer> map = new HashMap<Integer,Integer>();
        for(int i=0;i<nums.length;i++){        
            if(map.containsKey(target-nums[i])){
                res[0] = map.get(target-nums[i]);
                res[1] = i;
            }
            map.put(nums[i],i);
        }
        return res;
    }
}

方法二:先对数组进行排序,然后使用夹逼的方法找出满足条件的pair,原理是因为数组是有序的,那么假设当前结果比target大,那么左端序号右移只会使两个数的和更大,反之亦然。所以每次只会有一个选择,从而实现线性就可以求出结果。该算法的时间复杂度是O(nlogn+n)=O(nlogn),空间复杂度取决于排序算法。

public class Solution {
    public int[] twoSum(int[] nums, int target) {
        int[]res = new int[2];
        if(nums==null||nums.length<2)
            return null;
        Arrays.sort(nums);
        int f = 0;
        int l = nums.length - 1;
        while(f<l){
            if(nums[f] + nums[l] == target){
                res[0] = f;
                res[1] = l;
                return res;
            }else if(nums[f] + nums[l] > target){
                l--;
            }else{
                f++;
            }
        }
        return null;
    }
}

方法二存在的问题是nums的经过排序后内部的数字顺序已经改变,下标也改变了。

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值